#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>

int main ()
{
    std::stack<int> s; // LIFO

    s.push(1); // O(1)
    s.push(2);
    s.push(3);
    s.push(4);
    s.push(5);
    s.push(6);

    // while (!s.empty()) {
    //     std::cout << s.top() << "\n"; // O(1)
    //     s.pop(); // O(1)
    // }

    // std::set<int> skup;

    // skup.insert(1); // O(log n)
    // skup.insert(2);
    // skup.insert(5);
    // skup.insert(6);
    // skup.insert(2);
    // skup.insert(4);
    // skup.insert(6);
    // skup.insert(3);
    // skup.insert(5);

    // std::cout << "\t";
    // for (int x : skup) {
    //     std::cout << x << " ";
    // }
    // std::cout << "\n";


    std::unordered_set<int> skup;

    skup.insert(1); // O(1)
    skup.insert(2);
    skup.insert(5);
    skup.insert(6);
    skup.insert(2);
    skup.insert(4);
    skup.insert(6);
    skup.insert(3);
    skup.insert(5);

    // std::cout << "\t";
    // for (int x : skup) {
    //     std::cout << x << " ";
    // }

    // std::cout << "\n";

    // key -> value
    // 1 -> 2
    // 2 -> 3
    // 3 -> 4
    // 4 -> 14

    // std::map<std::string, int> mapa;

    // std::vector<std::string> reci = {
    //     "jabuka", "danas", "petak",
    //     "jabuka", "danas", "petak",
    //     "jabuka", "jabuka", "petak",
    //     "danas", "danas", "danas"
    // };

    // for (std::string rec : reci) {
    //     mapa[rec]++; // O(log n)
    // }

    // for (auto &p : mapa) {
    //     std::cout << "\t" << p.first << " " << p.second << "\n";
    // }


    std::unordered_map<std::string, int> mapa;

    std::vector<std::string> reci = {
        "jabuka", "danas", "petak",
        "jabuka", "danas", "petak",
        "jabuka", "jabuka", "petak",
        "danas", "danas", "danas"
    };

    for (std::string rec : reci) {
        mapa[rec]++; // O(1)
    }

    // for (auto &p : mapa) {
    //     std::cout << "\t" << p.first << " " << p.second << "\n";
    // }

    std::queue<int> red; // FIFO

    red.push(1); // O(1)
    red.push(5);
    red.push(6);
    red.push(7);
    red.push(2);

    // std::cout << "\t";
    // while (!red.empty()) {
    //     std::cout << red.front() << " "; // O(1)
    //     red.pop(); // O(1)
    // }

    // std::cout << "\n";

    std::priority_queue<int, std::vector<int>, std::greater<int>> heap;

    heap.push(4); // O(log n)
    heap.push(3);
    heap.push(1);
    heap.push(7);
    heap.push(8);
    heap.push(9);
    heap.push(2);

    std::cout << "\t";
    while (!heap.empty()) {
        std::cout << heap.top() << " "; // O(1)
        heap.pop(); // O(log n)
    }
    std::cout << "\n";


    return 0;
}