#include <iostream>
// Koristimo implementaciju steka iz standardne biblioteke
#include <stack>
#include <string>

int main ()
{
    // Uzimacemo karakter po karakter iz izraza pa nam treba stek karaktera
    std::stack<char> s;

    // Niska koja ce predstavljati izraz
    std::string expression;

    // Ucitavanje izraza sa standardnog ulaza
    std::cin >> expression;

    // Prolazimo kroz izraz karakter po karakter
    for (char c : expression) {
        // Ako naidjemo na otvorenu zagradu nju zelimo da dodamo na stek, a kad god budemo naisli na zatvorenu skinucemo sa steka jednu otvorenu, ukoliko su zagrade uparene stek ce prolaskom kroz ceo izraz postati prazan
        if (c == '(')
            // Dodavanje elementa na stek se vrsi metodom push
            s.push(c);
        // Ako naidjemo na zatvorenu zagradu onda je skidamo sa steka
        else if (c == ')') {
            // Ako je stek prazan u trenutku kada zelimo da skinemo zagradu sa steka (slucaj kada ima vise zatvorenih nego otvorenih zagrada) onda zagrade sigurno nisu uparene i samo ispisujemo poruku o tome i zavrsavamo program
            if (s.empty()) {
                std::cout << "Not matched!\n";
                return 0;
            }
            // Metodom pop se skida element sa vrha steka
            s.pop();
        }
        // Ukoliko imamo nesto sto nije ni ( ni ) onda samo idemo dalje, zanemarujemo taj karakter i idemo dalje, jer nas zanimaju samo zagrade
        else
            continue;
    }

    // Ukoliko je stek postao prazan, zagrade su uparene u suprotnom nisu
    std::cout << (s.empty() ? "Matched!\n" : "Not matched!\n");

    return 0;
}
